<?php

/**
 * Contao Open Source CMS
 * 
 * Copyright (C) 2005-2019 Leo Feyer
 * 
 * @copyright	Tim Gatzky 2019
 * @author		Tim Gatzky <info@tim-gatzky.de>
 * @package		pct_autogrid
 * @link		http://contao.org
 */

/**
 * Register the namespaces
 */
\Contao\ClassLoader::addNamespaces(array
(
	'PCT',
));


/**
 * Register the classes
 */
\Contao\ClassLoader::addClasses(array
(
	'PCT\AutoGrid\Core' 					=> 'system/modules/pct_autogrid/PCT/AutoGrid/Core.php',
	'PCT\AutoGrid\Controller' 				=> 'system/modules/pct_autogrid/PCT/AutoGrid/Controller.php',
	'PCT\AutoGrid\ContaoCallbacks' 			=> 'system/modules/pct_autogrid/PCT/AutoGrid/ContaoCallbacks.php',
	'PCT\AutoGrid\DcaHelper' 				=> 'system/modules/pct_autogrid/PCT/AutoGrid/DcaHelper.php',
	'PCT\AutoGrid\ContentAutoGridRow' 		=> 'system/modules/pct_autogrid/PCT/AutoGrid/ContentAutoGridRow.php',
	'PCT\AutoGrid\ContentAutoGridCol' 		=> 'system/modules/pct_autogrid/PCT/AutoGrid/ContentAutoGridCol.php',
	'PCT\AutoGrid\ContentAutoGridGrid' 		=> 'system/modules/pct_autogrid/PCT/AutoGrid/ContentAutoGridGrid.php',
	'PCT\AutoGrid\WidgetAutoGridRow' 		=> 'system/modules/pct_autogrid/PCT/AutoGrid/WidgetAutoGridRow.php',
	'PCT\AutoGrid\WidgetAutoGridCol' 		=> 'system/modules/pct_autogrid/PCT/AutoGrid/WidgetAutoGridCol.php',
	'PCT\AutoGrid\GridPreset' 				=> 'system/modules/pct_autogrid/PCT/AutoGrid/GridPreset.php',
	'PCT\AutoGrid\Backend\PageGridPreset' 	=> 'system/modules/pct_autogrid/PCT/AutoGrid/Backend/PageGridPreset.php',
	'PCT\AutoGrid\Models\ContentModel' 		=> 'system/modules/pct_autogrid/PCT/AutoGrid/Models/ContentModel.php',
	'PCT\AutoGrid\Models\FormFieldModel' 	=> 'system/modules/pct_autogrid/PCT/AutoGrid/Models/FormFieldModel.php',
	'PCT\AutoGrid\Backend\TableContent' 	=> 'system/modules/pct_autogrid/PCT/AutoGrid/Backend/TableContent.php',
	'PCT\AutoGrid\Backend\TableFormField' 	=> 'system/modules/pct_autogrid/PCT/AutoGrid/Backend/TableFormField.php',
	'PCT\AutoGrid\Backend\TableModule' 		=> 'system/modules/pct_autogrid/PCT/AutoGrid/Backend/TableModule.php',
	'PCT\AutoGrid\Backend\TableArticle' 	=> 'system/modules/pct_autogrid/PCT/AutoGrid/Backend/TableArticle.php',
	'PCT\AutoGrid\Backend\TableUser' 		=> 'system/modules/pct_autogrid/PCT/AutoGrid/Backend/TableUser.php',
	'PCT\AutoGrid\Backend\BackendIntegration'=> 'system/modules/pct_autogrid/PCT/AutoGrid/Backend/BackendIntegration.php',
));

/**
 * Register the templates
 */
\Contao\TemplateLoader::addFiles(array
(
	'ce_autogrid_row'						=> 'system/modules/pct_autogrid/templates',
	'ce_autogrid_col'						=> 'system/modules/pct_autogrid/templates',
	'ce_autogrid_grid'						=> 'system/modules/pct_autogrid/templates',
	'form_autogrid_row'						=> 'system/modules/pct_autogrid/templates',
	'form_autogrid_col'						=> 'system/modules/pct_autogrid/templates',
	'autogrid'      						=> 'system/modules/pct_autogrid/templates',
	'be_autogrid_wildcard'					=> 'system/modules/pct_autogrid/templates/backend',
	'be_autogrid_infobox'					=> 'system/modules/pct_autogrid/templates/backend',
	'be_js_autogrid'						=> 'system/modules/pct_autogrid/templates/backend',
	'be_autogrid_buttons'					=> 'system/modules/pct_autogrid/templates/backend',
	'be_page_grid_preset'					=> 'system/modules/pct_autogrid/templates/backend',
	'be_mod_grid_preview'					=> 'system/modules/pct_autogrid/templates/backend',
	'be_autogrid_row'						=> 'system/modules/pct_autogrid/templates/backend',
	'be_autogrid_col'						=> 'system/modules/pct_autogrid/templates/backend',
	'be_autogrid_grid'						=> 'system/modules/pct_autogrid/templates/backend',
));