<?php

/**
 * Contao Open Source CMS
 * 
 * Copyright (C) 2005-2013 Leo Feyer
 * 
 * @copyright	Tim Gatzky 2017, Premium Contao Webworks, Premium Contao Themes
 * @author		Tim Gatzky <info@tim-gatzky.de>
 * @package		pct_customelements
 * @link		http://contao.org
 */

namespace Contao\PCT;

/**
 * Class file
 * ContentElementSet
 */
class ContentElementSet extends \Contao\ContentElement
{
	/**
	 * Template
	 * @var string
	 */
	protected $strTemplate = 'ce_pct_contentelementset';
	
	public function generate()
	{
		if (TL_MODE == 'BE')
		{
			$lable = $this->alt ?: $this->type;
			if(strlen($GLOBALS['TL_LANG']['CONTENTELEMENTSETS'][$this->alt]) > 0)
			{
				$lable = $GLOBALS['TL_LANG']['CONTENTELEMENTSETS'][$this->alt];
			}
			
			$strReturn = '<p class="tl_small">'.$lable.'</p>';
			if ($this->headline != '')
			{
				$strReturn .= '<p><'. $this->hl .'>'. $this->headline .'</'. $this->hl .'></p>';
			}
			return $strReturn;
		}
	}
	
	/**
	 * Generate the content element
	 */
	protected function compile()
	{
		$arrCssId = $this->cssID;
		$arrCssId[1] .= ' '.$this->alt;
		
		if($this->type == 'pct_contentelementset_start')
		{
			$this->Template->isStart = true;
			
		}
		else if($this->type == 'pct_contentelementset_stop')
		{
			$this->Template->isStop = true;
		}
		
		$this->cssID = $arrCssId;
	}

}