<?php

/**
 * Contao Open Source CMS
 * 
 * Copyright (C) 2005-2013 Leo Feyer
 * 
 * @copyright	Tim Gatzky 2016, Premium Contao Webworks, Premium Contao Themes
 * @author		Tim Gatzky <info@tim-gatzky.de>
 * @package		pct_customelements
 * @link		http://contao.org
 */

/**
 * Namespace
 */
namespace PCT\CustomElements\Core\Maintenance;

/**
 * Imports
 */
use PCT\CustomElements\Core\Vault;

/**
 * Class file
 * VaultUpdater
 */
class VaultUpdater extends \Contao\Backend
{
	/**
	 * Run the update routines
	 * @return boolean
	 * Idea taken from \RebuildIndex
	 */
	public function run()
	{
		if(!\RequestToken::validate(\Contao\Input::get('rt')) && !\RequestToken::validate(\Contao\Input::post('REQUEST_TOKEN')))
		{
		  $this->Session->set('INVALID_TOKEN_URL', \Contao\Environment::get('request'));
		  $this->redirect('contao/confirm.php');
		}
		
		// render the page
		$objTemplate = new \Contao\BackendTemplate('be_maintenance_vaultupdater');
		$objTemplate->action = \ampersand(\Contao\Environment::get('request'));
		$objTemplate->indexContinue = $GLOBALS['TL_LANG']['MSC']['continue'];
		$objTemplate->theme = \Contao\Backend::getTheme();
		
		if($_GET['back'] || \Contao\Input::get('back'))
		{
			\Contao\Controller::redirect( \Contao\Controller::getReferer() );
		}
			
		// remove all attribute data from vault
		if(\Contao\Input::get('key') == 'removeAttributeDataFromVault')
		{
			$objTemplate->isActive = true;
			$objTemplate->headline = $GLOBALS['TL_LANG']['tl_maintenance']['pct_customelements']['removeAttributeDataFromVault'][0];
			
			$objDatabase = \Contao\Database::getInstance();
			$objEffected = $objDatabase->prepare("SELECT * FROM tl_pct_customelement_vault WHERE type!=?")->execute('wizard');
			
			$strBuffer = sprintf($GLOBALS['TL_LANG']['tl_maintenance']['pct_customelements']['removeAttributeDataFromVault_effected'],$objEffected->numRows);
			
			$objTemplate->runLabel = $GLOBALS['TL_LANG']['tl_maintenance']['pct_customelements']['removeAttributeDataFromVault_runLabel'];
			if(\Contao\Input::get('removeAttributeDataFromVault') == $objTemplate->runLabel)
			{
				$objDatabase->prepare("DELETE FROM tl_pct_customelement_vault WHERE type!=?")->execute('wizard');
				
				\Contao\Controller::redirect($this->addToUrl('removeAttributeDataFromVault='));
			}
			
			$objTemplate->content = $strBuffer;
		}

		$objTemplate->backLabel = $GLOBALS['TL_LANG']['MSC']['goBack'];
		
		return $objTemplate->parse();
	}
	
}