<?php

/**
 * Contao Open Source CMS
 * 
 * Copyright (C) 2005-2013 Leo Feyer
 * 
 * @copyright	Tim Gatzky 2015, Premium Contao Webworks, Premium Contao Themes
 * @author		Tim Gatzky <info@tim-gatzky.de>
 * @package		pct_customelements
 * @link		http://contao.org
 */


/**
 * List
 */
$new_contentelementset = array
(
	'label'               => &$GLOBALS['TL_LANG']['MSC']['new_contentelementset'],
	'icon'				  => PCT_CUSTOMELEMENTS_PATH.'/assets/img/new_set.gif',
	'href'                => 'act=paste&amp;mode=create&amp;rkey=contentelementset',
	'class'               => 'header_edit_all',
	'attributes'          => 'onclick="Backend.getScrollOffset()" accesskey="e"'	
);

$objContentElementSet = new \PCT\CustomElements\Core\ContentElementSet;
$arrContentElements = $objContentElementSet->getContentElementSets();
if(!empty($arrContentElements))
{
	\array_insert($GLOBALS['TL_DCA']['tl_content']['list']['global_operations'],0,array('new_contentelementset'=>$new_contentelementset));
}

/**
 * Config
 */
$GLOBALS['TL_DCA']['tl_content']['config']['onload_callback'][] = array('PCT\CustomElements\Backend\TableContent','modifyDca');

/**
 * Palettes
 */
$GLOBALS['TL_DCA']['tl_content']['palettes']['pct_contentelementset_start'] = '{type_legend},type,headline;;{template_legend:hide},customTpl;{protected_legend:hide},protected;{expert_legend:hide},guests,cssID,space;{invisible_legend:hide},invisible,start,stop';
$GLOBALS['TL_DCA']['tl_content']['palettes']['pct_contentelementset_stop'] = '';

		
/**
 * Fields
 */
// increase the default field size
if ( \version_compare(VERSION,'4.9','>=') && \is_array($GLOBALS['TL_DCA']['tl_content']['fields']['type']['sql']) )
{
	$GLOBALS['TL_DCA']['tl_content']['fields']['type']['sql']['length'] = 128;
}
else
{
	$GLOBALS['TL_DCA']['tl_content']['fields']['type']['sql'] = "varchar(128) NOT NULL default ''";
}

// redirect to key=contentelementset after user clicked the paste button
if(TL_MODE == 'BE' && \Input::get('rkey') == 'contentelementset' && \Input::get('act') == 'create')
{
	\Controller::redirect( \Controller::addToUrl('rkey=&amp;key=contentelementset&rt='.\Input::get('rt')) );
}

// export content element sets
if(TL_MODE == 'BE' && (boolean)\Config::get('contentelementset_export') === true)
{
	$GLOBALS['TL_DCA']['tl_content']['select']['buttons_callback'][] = array('PCT\CustomElements\Backend\TableContent','buttonsCallback');
}

// Content element set export has been called, redirect to export page
if(TL_MODE == 'BE' && (boolean)\Config::get('contentelementset_export') === true && \Input::post('contentelementset_export') != '' && !empty($_POST['IDS']))
{
	// store the selected element ids in the session
	\Session::getInstance()->set('contentelementset_export_ids',\Input::post('IDS'));
	
	$_SESSION['contentelementset_export_ids'] = \Input::post('IDS');
	
	// redirect to the export interface	
	\Controller::redirect( \Controller::addToUrl('key=contentelementset_export&rt='.\Input::get('rt')) );
}
			


