<?php

/**
 * Contao Open Source CMS
 * 
 * Copyright (C) 2005-2013 Leo Feyer
 * 
 * @copyright	Tim Gatzky 2013, Premium Contao Webworks, Premium Contao Themes
 * @author		Tim Gatzky <info@tim-gatzky.de>
 * @package		pct_customelements
 * @link		http://contao.org
 */

/**
 * Table tl_pct_customelement_plugin
 */
$GLOBALS['TL_DCA']['tl_pct_customelement_plugin'] = array
(
	// Config
	'config' => array
	(
		'dataContainer'               => 'Table',
		'switchToEdit'                => true,
		'enableVersioning'            => true,
		'onload_callback' => array
		(
			#array('PCT\CustomElements\Backend\TableCustomElementPlugins', 'checkPermission'),
			array('PCT\CustomElements\Backend\TableCustomElementPlugin', 'checkPluginsAvailable'),
			array('PCT\CustomElements\Backend\TableCustomElementPlugin', 'checkPluginRequirements'),
		),
		'sql' => array
		(
			'keys' => array
			(
				'id' => 'primary',
			)
		)
	),
	// List
	'list' => array
	(
		'sorting' => array
		(
			'mode'                    => 1,
			'fields'                  => array('plugin'),
			'flag'                    => 1,
			'panelLayout'             => 'limit',
			'disableGrouping'		  => true,
		),
		'label' => array
		(
			'fields'                  => array('plugin'),
			'format'                  => '%s',
			'label_callback'		  => array('PCT\CustomElements\Backend\TableCustomElementPlugin', 'getLabel'),
		),
		'global_operations' => array
		(
			'back' => array
			(
				'label'               => &$GLOBALS['TL_LANG']['MSC']['backBT'],
				'href'                => '',
				'class'               => 'header_back',
				'attributes'          => 'onclick="Backend.getScrollOffset();" accesskey="b"',
				'button_callback'     => array('PCT\CustomElements\Backend\TableCustomElementPlugin', 'backButton'),
			),
			'all' => array
			(
				'label'               => &$GLOBALS['TL_LANG']['MSC']['all'],
				'href'                => 'act=select',
				'class'               => 'header_edit_all',
				'attributes'          => 'onclick="Backend.getScrollOffset();" accesskey="e"'
			),
		),
		'operations' => array
		(
			'edit' => array
			(
				'label'               => &$GLOBALS['TL_LANG']['tl_pct_customelement_plugin']['edit'],
				'href'                => 'act=edit',
				'icon'                => 'edit.gif',
				'button_callback'     => array('PCT\CustomElements\Backend\TableCustomElementPlugin', 'editButton'),
			),
			'delete' => array
			(
				'label'               => &$GLOBALS['TL_LANG']['tl_pct_customelement_plugin']['delete'],
				'href'                => 'act=delete',
				'icon'                => 'delete.gif',
				'attributes'          => 'onclick="if(!confirm(\'' . $GLOBALS['TL_LANG']['MSC']['deleteConfirm'] . '\'))return false;Backend.getScrollOffset()"',
				'button_callback'     => array('PCT\CustomElements\Backend\TableCustomElementPlugin', 'deleteButton'),
			),
			'toggle' => array
			(
				'label'               => &$GLOBALS['TL_LANG']['tl_pct_customelement_plugin']['toggle'],
				'icon'                => 'visible.gif',
				'attributes'          => 'onclick="Backend.getScrollOffset();return AjaxRequest.toggleVisibility(this,%s)"',
				'button_callback'     => array('PCT\CustomElements\Backend\TableCustomElementPlugin', 'toggleIcon')
			),
			'show' => array
			(
				'label'               => &$GLOBALS['TL_LANG']['tl_pct_customelement_plugin']['show'],
				'href'                => 'act=show',
				'icon'                => 'show.gif'
			),
		)
	),
	// Palettes
	'palettes' => array
	(
		'__selector__'				  => array('protected','exclude'),
		'default'                  	  => '{title_legend},plugin,description;{exclude_legend:hide},exclude;{protected_legend:hide},protected;{expert_legend},published'
	),
	// Subpalettes
	'subpalettes' => array
	(
		'protected'					  => 'user_groups',
		'exclude'					  => 'customelements',
	),
	// Fields
	'fields' => array
	(
		'id' => array
		(
			'eval'					  => array('doNotCopy'=>true),
			'sql'                     => "int(10) unsigned NOT NULL auto_increment",
		),
		'tstamp' => array
		(
			'eval'					  => array('doNotCopy'=>true),
			'sql'                     => "int(10) unsigned NOT NULL default '0'",
		),
		'plugin' => array
		(
			'label'                   => &$GLOBALS['TL_LANG']['tl_pct_customelement_plugin']['plugin'],
			'exclude'                 => true,
			'inputType'               => 'select',
			'options_callback'        => array('PCT\CustomElements\Backend\TableCustomElementPlugin', 'getPlugins'),
			'eval'                    => array('tl_class'=>'','includeBlankOption'=>true,'submitOnChange'=>true,'unique'=>true),
			'sql'					  => "varchar(255) NOT NULL default ''",
		),
		'description' => array
		(
			'label'                   => &$GLOBALS['TL_LANG']['tl_pct_customelement_plugin']['description'],
			'exclude'                 => true,
			'eval'                    => array('tl_class'=>'long'),
			'input_field_callback'	  => array('PCT\CustomElements\Backend\TableCustomElementPlugin', 'getDescription'),
		),
		'exclude' => array
		(
			'label'                   => &$GLOBALS['TL_LANG']['tl_pct_customelement_plugin']['exclude'],
			'exclude'                 => true,
			'inputType'               => 'checkbox',
			'eval'                    => array('tl_class'=>'','submitOnChange'=>true),
			'sql'					  => "char(1) NOT NULL default ''",
		),
		'customelements' => array
		(
			'label'                   => &$GLOBALS['TL_LANG']['tl_pct_customelement_plugin']['customelements'],
			'exclude'                 => true,
			'inputType'               => 'checkbox',
			'foreignKey'              => 'tl_pct_customelement.title',
			'eval'                    => array('tl_class'=>'','multiple'=>true),
			'sql'					  => "blob NULL",
			'relation'                => array('type'=>'hasMany', 'load'=>'lazy')
		),
		'protected' => array
		(
			'label'                   => &$GLOBALS['TL_LANG']['tl_pct_customelement_plugin']['protected'],
			'exclude'                 => true,
			'inputType'               => 'checkbox',
			'eval'                    => array('tl_class'=>'','submitOnChange'=>true),
			'sql'					  => "char(1) NOT NULL default ''",
		),
		'user_groups' => array
		(
			'label'                   => &$GLOBALS['TL_LANG']['tl_pct_customelement_plugin']['user_groups'],
			'exclude'                 => true,
			'inputType'               => 'checkbox',
			'foreignKey'              => 'tl_user_group.name',
			'eval'                    => array('multiple'=>true,'tl_class'=>'clr',),
			'sql'					  => "blob NULL",
			'relation'                => array('type'=>'hasMany', 'load'=>'lazy')
		),
		'published' => array
		(
			'label'                   => &$GLOBALS['TL_LANG']['tl_pct_customelement_plugin']['published'],
			'exclude'                 => true,
			'inputType'               => 'checkbox',
			'eval'                    => array('tl_class'=>'w50'),
			'sql'					  =>  "char(1) NOT NULL default ''",
		),
	)
);
