<?php

/**
 * Contao Open Source CMS
 * 
 * Copyright (C) 2005-2013 Leo Feyer
 * 
 * @copyright	Tim Gatzky 2013
 * @author		Tim Gatzky <info@tim-gatzky.de>
 * @package		pct_iconpicker
 * @link		http://contao.org
 */

/**
 * Load language file
 */
$this->loadLanguageFile('tl_content');

/**
 * Selector
 */
$GLOBALS['TL_DCA']['tl_pct_customelement_attribute']['palettes']['__selector__'][] = 'addFontIcon';

/**
 * Palettes
 */
if(TL_MODE == 'BE')
{
	foreach($GLOBALS['TL_DCA']['tl_pct_customelement_attribute']['palettes'] as $type => $palette)
	{
		if($type != '__selector__')
		{
			$GLOBALS['TL_DCA']['tl_pct_customelement_attribute']['palettes'][$type] .= '{fontIcon_legend:hide},addFontIcon;';
		}
	}
}

/**
 * Subpalettes
 */
$GLOBALS['TL_DCA']['tl_pct_customelement_attribute']['subpalettes']['addFontIcon'] = 'fontIcon';

/**
 * Fields
 */
$GLOBALS['TL_DCA']['tl_pct_customelement_attribute']['fields']['addFontIcon'] = array
(
	'label'                   => &$GLOBALS['TL_LANG']['tl_pct_customelement_attribute']['addFontIcon'],
	'exclude'                 => true,
	'inputType'               => 'checkbox',
	'eval'                    => array('tl_class'=>'clr','submitOnChange'=>true),
	'sql'					  => "char(1) NOT NULL default ''",
);

$GLOBALS['TL_DCA']['tl_pct_customelement_attribute']['fields']['fontIcon'] = array
(
	'label'                   => &$GLOBALS['TL_LANG']['tl_pct_customelement_attribute']['fontIcon'],
	'exclude'                 => true,
	'inputType'               => 'text',
	'eval'                    => array('tl_class'=>'clr w50'),
	'explanation'             => 'fontIcons',
	'wizard' => array
	(
		array('PCT\IconPicker\IconPicker', 'fontIconPicker')
	),
	'sql'					  => "varchar(32) NOT NULL default ''",
);

/**
 * Attribute settings
 */
$type = 'iconpicker';
$search = array('__FIELDDEFINITION__','__EVAL__');
$replace = array('pagepicker,options','eval_mandatory');
$GLOBALS['TL_DCA']['tl_pct_customelement_attribute']['palettes'][$type] = str_replace($search, $replace, $GLOBALS['TL_DCA']['tl_pct_customelement_attribute']['palettes']['default']);

/**
 * Fields
 */
$GLOBALS['TL_DCA']['tl_pct_customelement_attribute']['fields']['options'][$type]['options'] = array
(
	'iconpicker',
);

$GLOBALS['TL_DCA']['tl_pct_customelement_attribute']['fields']['options'][$type]['reference'] = &$GLOBALS['TL_LANG']['tl_pct_customelement_attribute']['options']['iconpicker'];


