<?php

/**
 * Contao Open Source CMS
 *
 * Copyright (C) 2005-2013 Leo Feyer
 *
 * @copyright 	Tim Gatzky 2015, Premium Contao Webworks, Premium Contao Themes
 * @author  	Tim Gatzky <info@tim-gatzky.de>
 * @package  	pct_revolutionslider
 * @link 		http://contao.org
 */

/**
 * Namespace
 */
namespace RevolutionSlider\Frontend;


/**
 * Class file
 */
class ContentRevolutionSliderHyperlink extends \ContentElement
{
	/**
	 * Template
	 * @var
	 */
	protected $strTemplate = 'ce_revolutionslider_hyperlink';

	/**
	 * Display wildcard
	 */
	public function generate()
	{
		if (TL_MODE == 'BE')
		{
			$this->Template = new \BackendTemplate('be_wildcard');
			$this->Template->wildcard = '### REVOLUTION SLIDER HYPERLINK ###'.($this->url ? '<p>'.$this->url.'</p>' : '');
			$this->Template->title = $this->headline;
			
			return $this->Template->parse();
		}
		
		if(strlen($this->customTpl) > 0 && $this->customTpl != $this->strTemplate)
		{
			$this->strTemplate = $this->customTpl;
		}

		return parent::generate();
	}

	/**
	 * Generate the module
	 */
	protected function compile()
	{
		$arrCssID = $this->cssID;
		$arrClass = explode(' ', $arrCssID[1]);
		$arrClass[] = $this->strTemplate;
		$arrClass[] = 'caption';
		$arrClass[] = 'tp-caption';
		$arrCssID[1] = trim(implode(' ', array_unique($arrClass)));
		$this->cssID = $arrCssID;
		
		$objHyperlink = new \ContentHyperlink($this->getModel());
		$objHyperlink->cssID = $this->cssID;
		$objHyperlink->Template = $this->Template;
		return $objHyperlink->compile();
	}
}