<?php

/**
 * Contao Open Source CMS
 *
 * Copyright (C) 2005-2013 Leo Feyer
 *
 * @copyright 	Tim Gatzky 2015, Premium Contao Webworks, Premium Contao Themes
 * @author  	Tim Gatzky <info@tim-gatzky.de>
 * @package  	pct_revolutionslider
 * @link 		http://contao.org
 */

/**
 * Namespace
 */
namespace RevolutionSlider\Frontend;


/**
 * Class file
 */
class ContentRevolutionSliderImage extends \ContentElement
{
	/**
	 * Template
	 * @var
	 */
	protected $strTemplate = 'ce_revolutionslider_image';

	/**
	 * Display wildcard
	 */
	public function generate()
	{
		if (TL_MODE == 'BE')
		{
			$strImage = '';
			if($this->singleSRC)
			{
				$strImage = \FilesModel::findByPk($this->singleSRC)->path;
				$strImage = \Image::getHtml(\Controller::getImage($strImage,'150','75','center_center'));
			}
			
			$this->Template = new \BackendTemplate('be_wildcard');
			$this->Template->wildcard = '### REVOLUTION SLIDER IMAGE ###'.($strImage ? '<p>'.$strImage.'</p>':'');
			$this->Template->title = $this->headline;

			return $this->Template->parse();
		}
		
		if(strlen($this->customTpl) > 0 && $this->customTpl != $this->strTemplate)
		{
			$this->strTemplate = $this->customTpl;
		}

		return parent::generate();
	}

	/**
	 * Generate the module
	 */
	protected function compile()
	{
		if($this->singleSRC == '')
		{
			return '';
		}
		
		$arrCssID = $this->cssID;
		$arrClass = explode(' ', $arrCssID[1]);
		$arrClass[] = $this->strTemplate;
		$arrClass[] = 'caption';
		$arrClass[] = 'tp-caption';
		
		$arrCssID[1] = trim(implode(' ', array_unique($arrClass)));
		$this->cssID = $arrCssID;
		
		$this->singleSRC = \FilesModel::findByUuid($this->singleSRC)->path;
		
		$this->addImageToTemplate($this->Template, $this->arrData);
	}
}