<?php

/**
 * Contao Open Source CMS
 * 
 * Copyright (C) 2005-2013 Leo Feyer
 * 
 * @copyright	Tim Gatzky 2013, Premium Contao Webworks, Premium Contao Themes
 * @author		Tim Gatzky <info@tim-gatzky.de>
 * @package		revolutionslider
 * @link		http://contao.org
 */

/**
 * Load language files
 */
$this->loadLanguageFile('tl_revolutionslider_slides');

$GLOBALS['TL_DCA']['tl_content']['config']['onload_callback'][] = array('RevolutionSlider\Backend\TableContent', 'modifyPalettes');	
$GLOBALS['TL_DCA']['tl_content']['config']['onload_callback'][] = array('RevolutionSlider\Backend\TableContent', 'hideFields');	

/**
 * Palettes
 */
$GLOBALS['TL_DCA']['tl_content']['palettes']['revolutionslider'] 			= '{type_legend},type,headline;{select_legend},revolutionslider;{protected_legend:hide},protected;{expert_legend:hide},guests,cssID,space;{invisible_legend:hide},invisible,start,stop';
$GLOBALS['TL_DCA']['tl_content']['palettes']['revolutionslider_video'] 		= '{type_legend},type,headline;{source_legend},revolutionslider_videoType,multiSRC,url,singleSRC;{video_settings_legend},revolutionslider_data_autoplay,revolutionslider_video_loop,revolutionslider_data_nextslideatend,revolutionslider_video_controls,revolutionslider_video_fullscreen,revolutionslider_video_boxed;{template_legend:hide},customTpl;{protected_legend:hide},protected;{expert_legend:hide},guests,invisible,cssID,space';
$GLOBALS['TL_DCA']['tl_content']['palettes']['revolutionslider_text'] 		= '{type_legend},type;{text_legend},text,revolutionslider_text_fontsize,revolutionslider_text_bold,revolutionslider_text_invertcolor,revolutionslider_text_italic;{template_legend:hide},customTpl;{protected_legend:hide},protected;{expert_legend:hide},guests,invisible,cssID,space';
$GLOBALS['TL_DCA']['tl_content']['palettes']['revolutionslider_image'] 		= '{type_legend},type;{source_legend},singleSRC;{image_legend},alt,title,size,imageUrl,fullsize,useSVG;{template_legend:hide},customTpl;{protected_legend:hide},protected;{expert_legend:hide},guests,invisible,cssID,space';
$GLOBALS['TL_DCA']['tl_content']['palettes']['revolutionslider_hyperlink'] 	= '{type_legend},type;{link_legend},url,target,linkTitle,embed,titleText,rel;{template_legend:hide},customTpl;{protected_legend:hide},protected;{expert_legend:hide},guests,invisible,cssID,space';


/**
 * Selectors
 */
$GLOBALS['TL_DCA']['tl_content']['palettes']['__selector__'][] = 'revolutionslider_videoType';
$GLOBALS['TL_DCA']['tl_content']['palettes']['__selector__'][] = 'revolutionslider_OUT';
$GLOBALS['TL_DCA']['tl_content']['palettes']['__selector__'][] = 'revolutionslider_data_animation_start';
$GLOBALS['TL_DCA']['tl_content']['palettes']['__selector__'][] = 'revolutionslider_data_animation_end';
$GLOBALS['TL_DCA']['tl_content']['palettes']['__selector__'][] = 'revolutionslider_video_boxed';
		
/**
 * Subpalettes
 */
$sub_revolutionslider_IN = 'revolutionslider_data_rotation,revolutionslider_data_scale,revolutionslider_data_skew,revolutionslider_data_perspective,revolutionslider_data_origin,revolutionslider_data_opacity,revolutionslider_data_split,revolutionslider_data_delay';
$GLOBALS['TL_DCA']['tl_content']['subpalettes']['revolutionslider_data_animation_start_customin'] = $sub_revolutionslider_IN;

$GLOBALS['TL_DCA']['tl_content']['subpalettes']['revolutionslider_OUT'] = 'revolutionslider_data_easing_OUT,revolutionslider_data_animation_end,revolutionslider_data_speed_OUT,revolutionslider_data_start_OUT';
$sub_revolutionslider_OUT = 'revolutionslider_data_position_OUT,revolutionslider_data_rotation_OUT,revolutionslider_data_scale_OUT,revolutionslider_data_skew_OUT,revolutionslider_data_perspective_OUT,revolutionslider_data_origin_OUT,revolutionslider_data_opacity_OUT,revolutionslider_data_split_OUT,revolutionslider_data_delay_OUT';
$GLOBALS['TL_DCA']['tl_content']['subpalettes']['revolutionslider_data_animation_end_customout'] = $sub_revolutionslider_OUT;

$GLOBALS['TL_DCA']['tl_content']['subpalettes']['revolutionslider_video_boxed'] = 'revolutionslider_video_size';

/**
 * Dynamically add the permission check and parent table
 */
if (\Input::get('do') == 'revolutionslider')
{
	$GLOBALS['TL_DCA']['tl_content']['config']['ptable'] = 'tl_revolutionslider_slides';
	$GLOBALS['TL_DCA']['tl_content']['config']['onload_callback'][] = array('RevolutionSlider\Backend\TableContent', 'checkPermission');
	
	// remove revolutionslider from cte list to avoid adding a rs as content
	unset($GLOBALS['TL_CTE']['revolutionslider_node']['revolutionslider']);
	
	// remove cte from selection
	if($GLOBALS['REVOLUTIONSLIDER']['isBundledVersion'])
	{
		$arrAllowedCte = array('headline','text','image','hyperlink','revolutionslider_video');
		$arrAllowedIncludes = array();
		
		$arrAllowed = array_merge($arrAllowedCte,$arrAllowedIncludes);
		foreach($GLOBALS['TL_CTE'] as $node => $arrCte)
		{
			foreach($arrCte as $type => $class)
			{
				if(!in_array($type, $arrAllowed))
				{
					unset($GLOBALS['TL_CTE'][$node][$type]);
				}
			}
		}
	}
	
	// add slider palette on top of all available content elements
	foreach($GLOBALS['TL_DCA']['tl_content']['palettes'] as $cteType => $palette)
	{
		if( in_array($cteType, array('__selector__','revolutionslider')) || in_array($cteType, $GLOBALS['REVOLUTIONSLIDER']['cteIgnoreList']) )
		{
			continue;
		}
		
		$revolutionslider_IN = 'revolutionslider_data_easing,revolutionslider_data_linktoslide,revolutionslider_data_pos9grid,revolutionslider_data_position,revolutionslider_data_start,revolutionslider_data_speed,revolutionslider_data_animation_start';
		
		$GLOBALS['TL_DCA']['tl_content']['palettes'][$cteType] = '{slide_legend},'.$revolutionslider_IN.',revolutionslider_OUT;'.$palette;
	}
}
else
{
	if(TL_MODE == 'BE' && \Input::get('do') == 'article')
	{
		// dont show the video cte outside the revolution slider backend
		unset($GLOBALS['TL_CTE']['revolutionslider_node']['revolutionslider_text']);
		unset($GLOBALS['TL_CTE']['revolutionslider_node']['revolutionslider_image']);
		unset($GLOBALS['TL_CTE']['revolutionslider_node']['revolutionslider_hyperlink']);
	}
}
	
/**
 * Fields
 */
$GLOBALS['TL_DCA']['tl_content']['fields']['revolutionslider'] = array
(
	'label'                   => &$GLOBALS['TL_LANG']['tl_content']['revolutionslider'],
	'exclude'                 => true,
	'inputType'               => 'select',
	'options_callback'		  => array('RevolutionSlider\Backend\TableContent','getSliders'),
	'eval'                    => array('tl_class'=>'clr w50','insertBlankOption'=>true,'chosen'=>true),
	'sql'					  => "int(10) NOT NULL default '0'",
);

$GLOBALS['TL_DCA']['tl_content']['fields']['revolutionslider_data_easing'] = array
(
	'label'                   => &$GLOBALS['TL_LANG']['tl_content']['revolutionslider_data_easing'],
	'exclude'                 => true,
	'inputType'               => 'select',
	'options_callback'		  => array('RevolutionSlider\Core\RevolutionSlider','getTransitionEasings'),
	'eval'                    => array('tl_class'=>'clr w50','chosen'=>true),
	'sql'					  => "varchar(64) NOT NULL default ''",
);

$GLOBALS['TL_DCA']['tl_content']['fields']['revolutionslider_data_speed'] = array
(
	'label'                   => &$GLOBALS['TL_LANG']['tl_content']['revolutionslider_data_speed'],
	'exclude'                 => true,
	'inputType'               => 'text',
	'eval'                    => array('tl_class'=>'w50'),
	'sql'					  => "varchar(8) NOT NULL default '0.5'",
);

$GLOBALS['TL_DCA']['tl_content']['fields']['revolutionslider_data_start'] = array
(
	'label'                   => &$GLOBALS['TL_LANG']['tl_content']['revolutionslider_data_start'],
	'exclude'                 => true,
	'inputType'               => 'text',
	'default'				  => 0,
	'eval'                    => array('tl_class'=>'w50','rgxp'=>'digit'),
	'sql'					  => "varchar(4) NOT NULL default '1'",
);

$GLOBALS['TL_DCA']['tl_content']['fields']['revolutionslider_data_delay'] = array
(
	'label'                   => &$GLOBALS['TL_LANG']['tl_content']['revolutionslider_data_delay'],
	'exclude'                 => true,
	'inputType'               => 'text',
	'default'				  => 0,
	'eval'                    => array('tl_class'=>'w50','rgxp'=>'digit'),
	'sql'					  => "varchar(3) NOT NULL default '0'",
);
	
$GLOBALS['TL_DCA']['tl_content']['fields']['revolutionslider_data_animation_start'] = array
(
	'label'                   => &$GLOBALS['TL_LANG']['tl_content']['revolutionslider_data_animation_start'],
	'exclude'                 => true,
	'inputType'               => 'select',
	'default'				  => 'fade',
	'options_callback'		  => array('RevolutionSlider\Core\RevolutionSlider','getStartAnimationClasses'),
	'reference'				  => $GLOBALS['TL_LANG']['revolutionSliderAnimationClasses'],
	'eval'                    => array('tl_class'=>'clr','chosen'=>true,'submitOnChange'=>true),
	'sql'					  => "varchar(16) NOT NULL default ''",
);

$GLOBALS['TL_DCA']['tl_content']['fields']['revolutionslider_data_animation_end'] = array
(
	'label'                   => &$GLOBALS['TL_LANG']['tl_content']['revolutionslider_data_animation_end'],
	'exclude'                 => true,
	'inputType'               => 'select',
	'default'				  => 'fadeout',
	'options_callback'		  => array('RevolutionSlider\Core\RevolutionSlider','getEndAnimationClasses'),
	'reference'				  => $GLOBALS['TL_LANG']['revolutionSliderAnimationClasses'],
	'eval'                    => array('tl_class'=>'clr','chosen'=>true,'submitOnChange'=>true),
	'sql'					  => "varchar(16) NOT NULL default ''",
);

$GLOBALS['TL_DCA']['tl_content']['fields']['revolutionslider_data_position'] = array
(
	'label'                   => &$GLOBALS['TL_LANG']['tl_content']['revolutionslider_data_position'],
	'exclude'                 => true,
	'inputType'               => 'text',
	'eval'                    => array('multiple'=>true, 'size'=>3, 'tl_class'=>'w50'),
	'sql'					  => "varchar(255) NOT NULL default ''",
);

$GLOBALS['TL_DCA']['tl_content']['fields']['revolutionslider_data_pos9grid'] = array
(
	'label'                   => &$GLOBALS['TL_LANG']['tl_content']['revolutionslider_data_pos9grid'],
	'exclude'                 => true,
	'inputType'               => 'select',
	'options'		  		  => array('left top','center top','right top','left center','center center','right center','left bottom','center bottom','right bottom'),
	'reference'				  => $GLOBALS['TL_LANG']['tl_revolutionslider_slides']['data_bgposition'],
	'eval'                    => array('tl_class'=>'w50','includeBlankOption'=>true,'chosen'=>true),
	'sql'					  => "varchar(255) NOT NULL default ''",
);

$GLOBALS['TL_DCA']['tl_content']['fields']['revolutionslider_data_rotation'] = array
(
	'label'                   => &$GLOBALS['TL_LANG']['tl_content']['revolutionslider_data_rotation'],
	'exclude'                 => true,
	'inputType'               => 'text',
	'eval'                    => array('multiple'=>true, 'size'=>3, 'tl_class'=>'clr w50'),
	'sql'					  => "varchar(255) NOT NULL default ''",
);

$GLOBALS['TL_DCA']['tl_content']['fields']['revolutionslider_data_scale'] = array
(
	'label'                   => &$GLOBALS['TL_LANG']['tl_content']['revolutionslider_data_scale'],
	'exclude'                 => true,
	'inputType'               => 'text',
	'eval'                    => array('multiple'=>true, 'size'=>2, 'tl_class'=>'w50'),
	'sql'					  => "varchar(255) NOT NULL default ''",
);

$GLOBALS['TL_DCA']['tl_content']['fields']['revolutionslider_data_skew'] = array
(
	'label'                   => &$GLOBALS['TL_LANG']['tl_content']['revolutionslider_data_skew'],
	'exclude'                 => true,
	'inputType'               => 'text',
	'eval'                    => array('multiple'=>true, 'size'=>2, 'tl_class'=>'w50'),
	'sql'					  => "varchar(255) NOT NULL default ''",
);

$GLOBALS['TL_DCA']['tl_content']['fields']['revolutionslider_data_opacity'] = array
(
	'label'                   => &$GLOBALS['TL_LANG']['tl_content']['revolutionslider_data_opacity'],
	'exclude'                 => true,
	'inputType'               => 'text',
	'default'				  => '100',
	'eval'                    => array('tl_class'=>'w50','rgxp'=>'prcnt'),
	'sql'					  => "int(3) NOT NULL default '100'",
);

$GLOBALS['TL_DCA']['tl_content']['fields']['revolutionslider_data_perspective'] = array
(
	'label'                   => &$GLOBALS['TL_LANG']['tl_content']['revolutionslider_data_perspective'],
	'exclude'                 => true,
	'inputType'               => 'text',
	'eval'                    => array('tl_class'=>'w50','rgxp'=>'num','maxlength'=>4),
	'sql'					  => "char(4) NOT NULL default ''",
);

$GLOBALS['TL_DCA']['tl_content']['fields']['revolutionslider_data_origin'] = array
(
	'label'                   => &$GLOBALS['TL_LANG']['tl_content']['revolutionslider_data_origin'],
	'exclude'                 => true,
	'inputType'               => 'text',
	'eval'                    => array('multiple'=>true, 'size'=>2, 'tl_class'=>'w50','rgxp'=>'prcnt'),
	'sql'					  => "varchar(255) NOT NULL default ''",
);

$GLOBALS['TL_DCA']['tl_content']['fields']['revolutionslider_data_linktoslide'] = array
(
	'label'                   => &$GLOBALS['TL_LANG']['tl_content']['revolutionslider_data_linktoslide'],
	'exclude'                 => true,
	'inputType'               => 'select',
	'options_callback'		  => array('RevolutionSlider\Backend\TableContent','getSlides'),
	'eval'                    => array('includeBlankOption'=>true,'tl_class'=>'w50'),
	'sql'					  => "varchar(16) NOT NULL default ''",
);

$GLOBALS['TL_DCA']['tl_content']['fields']['revolutionslider_data_autoplay'] = array
(
	'label'                   => &$GLOBALS['TL_LANG']['tl_content']['revolutionslider_data_autoplay'],
	'exclude'                 => true,
	'inputType'               => 'checkbox',
	'eval'                    => array('tl_class'=>'w50'),
	'sql'					  => "char(1) NOT NULL default ''",
);

$GLOBALS['TL_DCA']['tl_content']['fields']['revolutionslider_data_split'] = array
(
	'label'                   => &$GLOBALS['TL_LANG']['tl_content']['revolutionslider_data_split'],
	'exclude'                 => true,
	'inputType'               => 'select',
	'options'				  => array('chars','lines','words'),
	'eval'                    => array('tl_class'=>'w50','includeBlankOption'=>true),
	'sql'					  => "varchar(8) NOT NULL default ''",
);

$GLOBALS['TL_DCA']['tl_content']['fields']['revolutionslider_data_nextslideatend'] = array
(
	'label'                   => &$GLOBALS['TL_LANG']['tl_content']['revolutionslider_data_nextslideatend'],
	'exclude'                 => true,
	'inputType'               => 'checkbox',
	'eval'                    => array('tl_class'=>'w50'),
	'sql'					  => "char(1) NOT NULL default ''",
);

$GLOBALS['TL_DCA']['tl_content']['fields']['revolutionslider_OUT'] = array
(
	'label'                   => &$GLOBALS['TL_LANG']['tl_content']['revolutionslider_OUT'],
	'exclude'                 => true,
	'inputType'               => 'checkbox',
	'eval'                    => array('tl_class'=>'clr','submitOnChange'=>true),
	'sql'					  => "char(1) NOT NULL default ''",
);

$GLOBALS['TL_DCA']['tl_content']['fields']['revolutionslider_videoType'] = array
(
	'label'                   => &$GLOBALS['TL_LANG']['tl_content']['revolutionslider_videoType'],
	'exclude'                 => true,
	'inputType'               => 'radio',
	#'options'				  => array('local','youtube','vimeo'),
	'options'				  => array('local','external'),
	'reference'				  => $GLOBALS['TL_LANG']['tl_content']['revolutionslider_videoType'],
	'eval'                    => array('submitOnChange'=>true,'tl_class'=>''),
	'sql'					  => "varchar(16) NOT NULL default ''",
);

$GLOBALS['TL_DCA']['tl_content']['fields']['revolutionslider_video_controls'] = array
(
	'label'                   => &$GLOBALS['TL_LANG']['tl_content']['revolutionslider_video_controls'],
	'exclude'                 => true,
	'inputType'               => 'checkbox',
	'eval'                    => array('tl_class'=>'w50'),
	'sql'					  => "char(1) NOT NULL default ''",
);

$GLOBALS['TL_DCA']['tl_content']['fields']['revolutionslider_video_loop'] = array
(
	'label'                   => &$GLOBALS['TL_LANG']['tl_content']['revolutionslider_video_loop'],
	'exclude'                 => true,
	'inputType'               => 'checkbox',
	'eval'                    => array('tl_class'=>'w50'),
	'sql'					  => "char(1) NOT NULL default ''",
);

$GLOBALS['TL_DCA']['tl_content']['fields']['revolutionslider_video_fullscreen'] = array
(
	'label'                   => &$GLOBALS['TL_LANG']['tl_content']['revolutionslider_video_fullscreen'],
	'exclude'                 => true,
	'inputType'               => 'checkbox',
	'eval'                    => array('tl_class'=>'clr w50'),
	'sql'					  => "char(1) NOT NULL default ''",
);

$GLOBALS['TL_DCA']['tl_content']['fields']['revolutionslider_video_boxed'] = array
(
	'label'                   => &$GLOBALS['TL_LANG']['tl_content']['revolutionslider_video_boxed'],
	'exclude'                 => true,
	'inputType'               => 'checkbox',
	'eval'                    => array('tl_class'=>'clr w50','submitOnChange'=>true),
	'sql'					  => "char(1) NOT NULL default ''",
);

$GLOBALS['TL_DCA']['tl_content']['fields']['revolutionslider_video_size'] = array
(
	'label'                   => &$GLOBALS['TL_LANG']['tl_content']['revolutionslider_video_size'],
	'exclude'                 => true,
	'inputType'               => 'text',
	'eval'                    => array('rgxp'=>'digit', 'multiple'=>true, 'nospace'=>true, 'tl_class'=>'clr w50', 'size'=>2),
	'sql'					  => "varchar(64) NOT NULL default ''",
);

// rs text element
$GLOBALS['TL_DCA']['tl_content']['fields']['revolutionslider_text_invertcolor'] = array
(
	'label'                   => &$GLOBALS['TL_LANG']['tl_content']['revolutionslider_text_invertcolor'],
	'exclude'                 => true,
	'inputType'               => 'checkbox',
	'eval'                    => array('tl_class'=>'clr w50'),
	'sql'					  => "char(1) NOT NULL default ''",
);

$GLOBALS['TL_DCA']['tl_content']['fields']['revolutionslider_text_bold'] = array
(
	'label'                   => &$GLOBALS['TL_LANG']['tl_content']['revolutionslider_text_bold'],
	'exclude'                 => true,
	'inputType'               => 'checkbox',
	'eval'                    => array('tl_class'=>'w50 m12'),
	'sql'					  => "char(1) NOT NULL default ''",
);

$GLOBALS['TL_DCA']['tl_content']['fields']['revolutionslider_text_italic'] = array
(
	'label'                   => &$GLOBALS['TL_LANG']['tl_content']['revolutionslider_text_italic'],
	'exclude'                 => true,
	'inputType'               => 'checkbox',
	'eval'                    => array('tl_class'=>'w50'),
	'sql'					  => "char(1) NOT NULL default ''",
);

$GLOBALS['TL_DCA']['tl_content']['fields']['revolutionslider_text_fontsize'] = array
(
	'label'                   => &$GLOBALS['TL_LANG']['tl_content']['revolutionslider_text_fontsize'],
	'exclude'                 => true,
	'inputType'               => 'text',
	'default'				  => '14',
	'eval'                    => array('tl_class'=>'w50','rgxp'=>'digit'),
	'sql'					  => "varchar(8) NOT NULL default ''",
);


// OUT going animations
$GLOBALS['TL_DCA']['tl_content']['fields']['revolutionslider_data_easing_OUT'] = array
(
	'label'                   => &$GLOBALS['TL_LANG']['tl_content']['revolutionslider_data_easing'],
	'exclude'                 => true,
	'inputType'               => 'select',
	'options_callback'		  => array('RevolutionSlider\Core\RevolutionSlider','getTransitionEasings'),
	'eval'                    => array('tl_class'=>'clr w50','chosen'=>true),
	'sql'					  => "varchar(64) NOT NULL default ''",
);

$GLOBALS['TL_DCA']['tl_content']['fields']['revolutionslider_data_speed_OUT'] = array
(
	'label'                   => &$GLOBALS['TL_LANG']['tl_content']['revolutionslider_data_speed'],
	'exclude'                 => true,
	'inputType'               => 'text',
	'eval'                    => array('tl_class'=>'w50 clr','rgxp'=>'digit'),
	'sql'					  => "varchar(8) NOT NULL default '0.5'",
);

$GLOBALS['TL_DCA']['tl_content']['fields']['revolutionslider_data_start_OUT'] = array
(
	'label'                   => &$GLOBALS['TL_LANG']['tl_content']['revolutionslider_data_start'],
	'exclude'                 => true,
	'inputType'               => 'text',
	'default'				  => 0,
	'eval'                    => array('tl_class'=>'w50','rgxp'=>'digit'),
	'sql'					  => "varchar(4) NOT NULL default '1'",
);

$GLOBALS['TL_DCA']['tl_content']['fields']['revolutionslider_data_position_OUT'] = array
(
	'label'                   => &$GLOBALS['TL_LANG']['tl_content']['revolutionslider_data_position'],
	'exclude'                 => true,
	'inputType'               => 'text',
	'eval'                    => array('multiple'=>true, 'size'=>3, 'tl_class'=>'clr w50','rgxp'=>'digit'),
	'sql'					  =>  "varchar(255) NOT NULL default ''",
);

$GLOBALS['TL_DCA']['tl_content']['fields']['revolutionslider_data_rotation_OUT'] = array
(
	'label'                   => &$GLOBALS['TL_LANG']['tl_content']['revolutionslider_data_rotation'],
	'exclude'                 => true,
	'inputType'               => 'text',
	'eval'                    => array('multiple'=>true, 'size'=>3, 'tl_class'=>'w50'),
	'sql'					  => "varchar(255) NOT NULL default ''",
);

$GLOBALS['TL_DCA']['tl_content']['fields']['revolutionslider_data_scale_OUT'] = array
(
	'label'                   => &$GLOBALS['TL_LANG']['tl_content']['revolutionslider_data_scale'],
	'exclude'                 => true,
	'inputType'               => 'text',
	'eval'                    => array('multiple'=>true, 'size'=>2, 'tl_class'=>'w50'),
	'sql'					  => "varchar(255) NOT NULL default ''",
);

$GLOBALS['TL_DCA']['tl_content']['fields']['revolutionslider_data_skew_OUT'] = array
(
	'label'                   => &$GLOBALS['TL_LANG']['tl_content']['revolutionslider_data_skew'],
	'exclude'                 => true,
	'inputType'               => 'text',
	'eval'                    => array('multiple'=>true, 'size'=>2, 'tl_class'=>'w50'),
	'sql'					  => "varchar(255) NOT NULL default ''",
);

$GLOBALS['TL_DCA']['tl_content']['fields']['revolutionslider_data_opacity_OUT'] = array
(
	'label'                   => &$GLOBALS['TL_LANG']['tl_content']['revolutionslider_data_opacity'],
	'exclude'                 => true,
	'inputType'               => 'text',
	'default'				  => '100',
	'eval'                    => array('tl_class'=>'w50','rgxp'=>'prcnt'),
	'sql'					  => "int(3) NOT NULL default '100'",
);

$GLOBALS['TL_DCA']['tl_content']['fields']['revolutionslider_data_perspective_OUT'] = array
(
	'label'                   => &$GLOBALS['TL_LANG']['tl_content']['revolutionslider_data_perspective'],
	'exclude'                 => true,
	'inputType'               => 'text',
	'eval'                    => array('tl_class'=>'w50','rgxp'=>'num','maxlength'=>4),
	'sql'					  => "char(4) NOT NULL default ''",
);

$GLOBALS['TL_DCA']['tl_content']['fields']['revolutionslider_data_origin_OUT'] = array
(
	'label'                   => &$GLOBALS['TL_LANG']['tl_content']['revolutionslider_data_origin'],
	'exclude'                 => true,
	'inputType'               => 'text',
	'eval'                    => array('multiple'=>true, 'size'=>2, 'tl_class'=>'w50','rgxp'=>'prcnt'),
	'sql'					  =>  "varchar(255) NOT NULL default ''",
);

$GLOBALS['TL_DCA']['tl_content']['fields']['revolutionslider_data_split_OUT'] = array
(
	'label'                   => &$GLOBALS['TL_LANG']['tl_content']['revolutionslider_data_split'],
	'exclude'                 => true,
	'inputType'               => 'select',
	'options'				  => array('chars','lines','words'),
	'eval'                    => array('tl_class'=>'w50','includeBlankOption'=>true),
	'sql'					  => "varchar(8) NOT NULL default ''",
);

$GLOBALS['TL_DCA']['tl_content']['fields']['revolutionslider_data_delay_OUT'] = array
(
	'label'                   => &$GLOBALS['TL_LANG']['tl_content']['revolutionslider_data_delay'],
	'exclude'                 => true,
	'inputType'               => 'text',
	'default'				  => 0,
	'eval'                    => array('tl_class'=>'w50','rgxp'=>'prcnt'),
	'sql'					  => "char(3) NOT NULL default ''",
);

$GLOBALS['TL_DCA']['tl_content']['fields']['revolutionslider_data_frames'] = array
(
	'label'                   => &$GLOBALS['TL_LANG']['tl_content']['revolutionslider_data_frames'],
	'exclude'                 => true,
	'inputType'               => 'textarea',
	'eval'                    => array('tl_class'=>''),
	'sql'					  => "mediumtext NULL",
);

$GLOBALS['TL_DCA']['tl_content']['fields']['useSVG'] = array
(
	'label'                   => &$GLOBALS['TL_LANG']['tl_content']['useSVG'],
	'exclude'                 => true,
	'inputType'               => 'checkbox',
	'eval'                    => array('tl_class'=>'m12 w50'),
	'sql'					  => "char(1) NOT NULL default ''",
);