<?php

/**
 * Contao Open Source CMS
 * 
 * Copyright (C) 2005-2013 Leo Feyer
 * 
 * @copyright	Tim Gatzky 2019
 * @author		Tim Gatzky <info@tim-gatzky.de>
 * @package		pct_theme_settings
 * @link		http://contao.org
 */
 

/**
 * Namespace
 */
namespace PCT\ThemeSettings\Backend;

/**
 * Class file
 * TableContent
 */
class TableContent extends \Contao\Backend
{
	/**
	 * Remove the autogrid fields in autogrid_wrapper elements
	 * @param object
	 */
	public function modifyDca($objDC)
	{
		if( $objDC->activeRecord === null )
		{
			$objDC->activeRecord = \Contao\ContentModel::findByPk($objDC->id);
		}

		// load options by type
		foreach(array('style','color','border','format') as $k)
		{
			if( isset($GLOBALS['PCT_THEME_SETTINGS'][$k.'_classes::'.$objDC->activeRecord->type]) )
			{
				$GLOBALS['TL_DCA'][$objDC->table]['fields'][$k.'_css']['options'] = $GLOBALS['PCT_THEME_SETTINGS'][$k.'_classes::'.$objDC->activeRecord->type];
			}
		} 
		
		// table has different style classes
		if($objDC->activeRecord->type == 'table')
		{
		}
		else if($objDC->activeRecord->type == 'list')
		{
			$GLOBALS['TL_DCA'][$objDC->table]['fields']['listtype']['eval']['tl_class'] .= ' w50';
			$GLOBALS['TL_DCA'][$objDC->table]['fields']['listitems']['eval']['tl_class'] .= ' clr';
		}
		else if($objDC->activeRecord->type == 'text')
		{
		}
		else if($objDC->activeRecord->type == 'hyperlink')
		{
		}
		else if($objDC->activeRecord->type == 'headline')
		{
			$GLOBALS['TL_DCA'][$objDC->table]['fields']['align_css']['eval']['tl_class'] .= ' clr';
		}
		else if($objDC->activeRecord->type == 'image')
		{
			$GLOBALS['TL_DCA'][$objDC->table]['fields']['align_css']['eval']['tl_class'] .= ' clr';
		}
		else if($objDC->activeRecord->type == 'accordionSingle' || $objDC->activeRecord->type == 'accordionStart')
		{
			unset($GLOBALS['TL_DCA'][$objDC->table]['fields']['style_css']['eval']['includeBlankOption']);
		}

		
	}

}