<?php

/**
 * Contao Open Source CMS
 * 
 * Copyright (C) 2005-2013 Leo Feyer
 * 
 * @copyright	Tim Gatzky 2019
 * @author		Tim Gatzky <info@tim-gatzky.de>
 * @package		pct_theme_settings
 * @link		http://contao.org
 */
 

/**
 * Load language files
 */
\Contao\System::loadLanguageFile('dca_theme_settings');
\Contao\System::loadLanguageFile('tl_style');
 
/**
 * Config
 */
$GLOBALS['TL_DCA']['tl_module']['config']['onload_callback'][] = array('PCT\ThemeSettings\Backend\TableModule', 'modifyDca'); 


/**
 * Palettes
 */
// Append news sorting field and news filter palette
if( strpos($GLOBALS['TL_DCA']['tl_module']['palettes']['newslist'],'news_order') === false )
{
	$GLOBALS['TL_DCA']['tl_module']['palettes']['newslist'] = str_replace
	(
		'skipFirst',
		'skipFirst,news_order;',
		$GLOBALS['TL_DCA']['tl_module']['palettes']['newslist']	
	);
}

// pageimage,article
$GLOBALS['TL_DCA']['tl_module']['palettes']['pageimage'] = '{title_legend},name,type;{config_legend},imgSize,bgposition,showLevel;{template_legend:hide},customTpl;{protected_legend:hide},protected;{expert_legend:hide},guests,cssID,space';
$GLOBALS['TL_DCA']['tl_module']['palettes']['pagearticle'] = '{title_legend},name,type;{config_legend},showLevel;{template_legend:hide},customTpl;{protected_legend:hide},protected;{expert_legend:hide},guests,cssID,space';
// privacy
$GLOBALS['TL_DCA']['tl_module']['palettes']['privacy_in'] = '{title_legend},name,headline,type;{config_legend},privacy_lbl_1,privacy_txt_1;privacy_lbl_2,privacy_txt_2;privacy_lbl_3,privacy_txt_3;html;privacy_url_1,privacy_url_2;{template_legend:hide},customTpl;{cookie_legend:hide},privacy_cookie_expires;{protected_legend:hide},protected;{expert_legend:hide},guests,cssID,space';
$GLOBALS['TL_DCA']['tl_module']['palettes']['privacy_out'] = '{title_legend},name,type;{redirect_legend},jumpTo,redirectBack;{protected_legend:hide},protected;{template_legend:hide},customTpl;{expert_legend:hide},guests,cssID,space';
// portfoliolist
$GLOBALS['TL_DCA']['tl_module']['palettes']['portfoliolist'] = '{title_legend},name,headline,type;{config_legend},news_archives,numberOfItems,news_featured,perPage,skipFirst,news_order;{layout_legend:hide},style_css,layout_css;{template_legend:hide},news_metaFields,news_template,customTpl;{image_legend:hide},imgSize;{protected_legend:hide},protected;{expert_legend:hide},guests,cssID,,space';
// portfoliofilter
$GLOBALS['TL_DCA']['tl_module']['palettes']['portfoliofilter'] = '{title_legend},name,headline,type;{config_legend},news_readerModule;{filter_legend:hide},news_filters,news_sysfilter,news_filter_multiple;{layout_legend:hide},align_css,style_css,color_css;{template_legend:hide},customTpl;{protected_legend:hide},protected;{expert_legend:hide},guests,cssID,space';
// portfolioreader
$GLOBALS['TL_DCA']['tl_module']['palettes']['portfolioreader'] = '{title_legend},name,headline,type;{config_legend},news_archives;{template_legend:hide},news_metaFields,news_template,customTpl;{image_legend:hide},imgSize;{protected_legend:hide},protected;{expert_legend:hide},guests,cssID,space';


/**
 * Fields
 */
\array_insert($GLOBALS['TL_DCA']['tl_module']['fields'], 0, $GLOBALS['PCT_THEME_SETTINGS']['fields']);
\array_insert($GLOBALS['TL_DCA']['tl_module']['fields'], 0, array
(
	'align_css'    => array
	(
		'label'                   => &$GLOBALS['TL_LANG']['dca_theme_settings']['align_css'],
		'inputType'               => 'select',
		'options'				  => $GLOBALS['PCT_THEME_SETTINGS']['align_classes'],
		'reference'				  => &$GLOBALS['TL_LANG']['dca_theme_settings']['align_css'],
		'eval'                    => array('includeBlankOption'=>true, 'tl_class'=>'w50'),
		'sql'                     => "varchar(32) NOT NULL default ''"
	),
	'color_css'    => array
	(
		'label'                   => &$GLOBALS['TL_LANG']['dca_theme_settings']['color_css'],
		'inputType'               => 'select',
		'options'				  => $GLOBALS['PCT_THEME_SETTINGS']['color_classes'],
		'reference'				  => &$GLOBALS['TL_LANG']['dca_theme_settings']['color_css'],
		'eval'                    => array('includeBlankOption'=>true, 'tl_class'=>'w50'),
		'sql'                     => "varchar(32) NOT NULL default ''"
	),
	'style_css'    => array
	(
		'label'                   => &$GLOBALS['TL_LANG']['dca_theme_settings']['style_css'],
		'inputType'               => 'select',
		'options'				  => $GLOBALS['PCT_THEME_SETTINGS']['style_classes'],
		'reference'				  => &$GLOBALS['TL_LANG']['dca_theme_settings']['style_css'],
		'eval'                    => array('tl_class'=>'w50'),
		'sql'                     => "varchar(32) NOT NULL default ''"
	),
	'layout_css'    => array
	(
		'label'                   => &$GLOBALS['TL_LANG']['dca_theme_settings']['layout_css'],
		'inputType'               => 'select',
		'options'				  => $GLOBALS['PCT_THEME_SETTINGS']['layout_classes'],
		'reference'				  => &$GLOBALS['TL_LANG']['dca_theme_settings']['layout_css'],
		'eval'                    => array('tl_class'=>'w50'),
		'sql'                     => "varchar(32) NOT NULL default ''"
	),
	// news filter
	'news_filters'    => array
	(
		'label'                   => &$GLOBALS['TL_LANG']['tl_module']['news_filters'],
		'inputType'               => 'optionWizard',
		'eval'                    => array('tl_class'=>'clr'),
		'sql'                     => "blob NULL"
	),
	'news_sysfilter'    => array
	(
		'label'                   => &$GLOBALS['TL_LANG']['tl_module']['news_sysfilter'],
		'inputType'               => 'checkbox',
		'eval'                    => array('tl_class'=>'clr'),
		'sql'                     => "char(1) NOT NULL default ''"
	),
	'news_portfoliolistModule'    => array
	(
		'label'                   => &$GLOBALS['TL_LANG']['tl_module']['news_portfoliolistModule'],
	),
	'news_filter_multiple'    => array
	(
		'label'                   => &$GLOBALS['TL_LANG']['tl_module']['news_filter_multiple'],
		'inputType'               => 'checkbox',
		'eval'                    => array('tl_class'=>'clr'),
		'sql'                     => "char(1) NOT NULL default ''"
	),
	// privacy
	'privacy_lbl_1'    => array
	(
		'label'                   => &$GLOBALS['TL_LANG']['tl_module']['privacy_lbl_1'],
		'inputType'               => 'text',
		'eval'                    => array('maxchars'=>196,'tl_class'=>''),
		'sql'                     => "varchar(128) NOT NULL default ''"
	),
	'privacy_txt_1'    => array
	(
		'label'                   => &$GLOBALS['TL_LANG']['tl_module']['privacy_txt_1'],
		'inputType'               => 'textarea',
		'eval'                    => array('tl_class'=>'','allowHtml'=>true),
		'sql'                     => "tinytext NULL"
	),
	'privacy_lbl_2'    => array
	(
		'label'                   => &$GLOBALS['TL_LANG']['tl_module']['privacy_lbl_2'],
		'inputType'               => 'text',
		'eval'                    => array('maxchars'=>196,'tl_class'=>''),
		'sql'                     => "varchar(128) NOT NULL default ''"
	),
	'privacy_txt_2'    => array
	(
		'label'                   => &$GLOBALS['TL_LANG']['tl_module']['privacy_txt_2'],
		'inputType'               => 'textarea',
		'eval'                    => array('tl_class'=>'','allowHtml'=>true),
		'sql'                     => "tinytext NULL"
	),
	'privacy_lbl_3'    => array
	(
		'label'                   => &$GLOBALS['TL_LANG']['tl_module']['privacy_lbl_3'],
		'inputType'               => 'text',
		'eval'                    => array('maxchars'=>196,'tl_class'=>''),
		'sql'                     => "varchar(128) NOT NULL default ''"
	),
	'privacy_txt_3'    => array
	(
		'label'                   => &$GLOBALS['TL_LANG']['tl_module']['privacy_txt_3'],
		'inputType'               => 'textarea',
		'eval'                    => array('tl_class'=>'','allowHtml'=>true),
		'sql'                     => "tinytext NULL"
	),
	'privacy_url_1'    => array
	(
		'label'                   => &$GLOBALS['TL_LANG']['tl_module']['privacy_url_1'],
		'exclude'                 => true,
		'search'                  => true,
		'inputType'               => 'text',
		'eval'                    => array('rgxp'=>'url', 'decodeEntities'=>true, 'maxlength'=>255, 'dcaPicker'=>true, 'fieldType'=>'radio', 'filesOnly'=>true, 'tl_class'=>'w50 wizard'),
		'sql'                     => "varchar(255) NOT NULL default ''"
	),
	'privacy_url_2'    => array
	(
		'label'                   => &$GLOBALS['TL_LANG']['tl_module']['privacy_url_2'],
		'exclude'                 => true,
		'search'                  => true,
		'inputType'               => 'text',
		'eval'                    => array('rgxp'=>'url', 'decodeEntities'=>true, 'maxlength'=>255, 'dcaPicker'=>true,'fieldType'=>'radio', 'filesOnly'=>true, 'tl_class'=>'w50 wizard'),
		'sql'                     => "varchar(255) NOT NULL default ''"
	),
	'privacy_cookie_expires'    => array
	(
		'label'                   => &$GLOBALS['TL_LANG']['tl_module']['privacy_cookie_expires'],
		'inputType'               => 'select',
		'default'				  => 30,
		'options'				  => array(30,15,7,1),
		'eval'                    => array('maxlength'=>5),
		'sql'                     => "smallint(5) unsigned NOT NULL default '0'"
	),
	// page image
	'bgposition'    => array
	(
		'label'                   => &$GLOBALS['TL_LANG']['tl_style']['bgposition'],
		'inputType'               => 'select',
		'options'                 => $GLOBALS['PCT_THEME_SETTINGS']['bgposition_classes'],
		'reference'               => $GLOBALS['TL_LANG']['dca_theme_settings']['values'],
		'eval'                    => array('includeBlankOption'=>true, 'tl_class'=>'w50','chosen'=>true),
		'sql'                     => "varchar(32) NOT NULL default ''"
	),
));

// add sorting as news_order option
$GLOBALS['TL_DCA']['tl_module']['fields']['news_order']['options'][] = 'sorting';

if( version_compare(VERSION, '3.5','<=') )
{
	\Contao\Controller::loadDataContainer('tl_content');
	$GLOBALS['TL_DCA']['tl_module']['fields']['privacy_url_1']['wizard'] = array( array('tl_content', 'pagePicker') );
	$GLOBALS['TL_DCA']['tl_module']['fields']['privacy_url_2']['wizard'] = array( array('tl_content', 'pagePicker') );
}

	