<?php

/**
 * Contao Open Source CMS
 *
 * Copyright (C) 2005-2013 Leo Feyer
 *
 * @copyright	Tim Gatzky 2019
 * @author		Tim Gatzky <info@tim-gatzky.de>
 * @package		pct_theme_settings
 * @link		http://contao.org
 */


/**
 * Load language files
 */
\Contao\System::loadLanguageFile('dca_theme_settings');
\Contao\System::loadLanguageFile('tl_content');


/**
 * Selector
 */
$GLOBALS['TL_DCA']['tl_page']['palettes']['__selector__'][] = 'addImage';
$GLOBALS['TL_DCA']['tl_page']['palettes']['__selector__'][] = 'addArticle';


/**
 * Subpalettes
 */
$GLOBALS['TL_DCA']['tl_page']['subpalettes']['addImage'] = 'singleSRC,imgHeadline,imgSubheadline,style_css,height_css';
$GLOBALS['TL_DCA']['tl_page']['subpalettes']['addArticle'] = 'article';


/**
 * Palettes
 */
$GLOBALS['TL_DCA']['tl_page']['palettes']['root'] = str_replace('includeLayout;','includeLayout;{theme_settings:hide},ribbon,addImage,addArticle;',$GLOBALS['TL_DCA']['tl_page']['palettes']['root']);
$GLOBALS['TL_DCA']['tl_page']['palettes']['regular'] = str_replace('includeLayout;','includeLayout;{theme_settings:hide},ribbon,addImage,addArticle;',$GLOBALS['TL_DCA']['tl_page']['palettes']['regular']);
$GLOBALS['TL_DCA']['tl_page']['palettes']['forward'] = str_replace('includeLayout;','includeLayout;{theme_settings:hide},ribbon,addImage,addArticle;',$GLOBALS['TL_DCA']['tl_page']['palettes']['forward']);
$GLOBALS['TL_DCA']['tl_page']['palettes']['redirect'] = str_replace('includeLayout;','includeLayout;{theme_settings:hide},ribbon,addImage,addArticle;',$GLOBALS['TL_DCA']['tl_page']['palettes']['redirect']);
$GLOBALS['TL_DCA']['tl_page']['palettes']['error_403'] = str_replace('includeLayout;','includeLayout;{theme_settings:hide},ribbon,addImage,addArticle;',$GLOBALS['TL_DCA']['tl_page']['palettes']['error_403']);
$GLOBALS['TL_DCA']['tl_page']['palettes']['error_404'] = str_replace('includeLayout;','includeLayout;{theme_settings:hide},ribbon,addImage,addArticle;',$GLOBALS['TL_DCA']['tl_page']['palettes']['error_404']);

/**
 * Fields
 */
\array_insert($GLOBALS['TL_DCA']['tl_page']['fields'], 0, array
(
	'ribbon'    => array
	(
		'label'                   => &$GLOBALS['TL_LANG']['tl_page']['ribbon'],
		'exclude'                 => true,
		'inputType'               => 'text',
		'eval'                    => array('tl_class'=>'w50','maxlength'=>255),
		'sql'                     => "varchar(255) NOT NULL default ''"
	),
	'addImage'    => array
	(
		'label'                   => &$GLOBALS['TL_LANG']['tl_page']['addImage'],
		'exclude'                 => true,
		'inputType'               => 'checkbox',
		'eval'                    => array('submitOnChange'=>true,'tl_class'=>'clr'),
		'sql'                     => "char(1) NOT NULL default ''"
	),
	'singleSRC'    => array
	(
		'label'                   => &$GLOBALS['TL_LANG']['tl_content']['singleSRC'],
		'exclude'                 => true,
		'inputType'               => 'fileTree',
		'eval'                    => array('filesOnly'=>true, 'fieldType'=>'radio', 'mandatory'=>true, 'tl_class'=>'clr'),
		'sql'                     => "binary(16) NULL"
	),
	'style_css'    => array
	(
		'label'                   => &$GLOBALS['TL_LANG']['tl_page']['style_css'],
		'exclude'                 => true,
		'inputType'               => 'select',
		'options'				  => array('style1','style2','style3'),
		'reference'				  => $GLOBALS['TL_LANG']['dca_theme_settings']['style_css'],
		'eval'                    => array('tl_class'=>'clr w50','includeBlankOption'=>false),
		'sql'                     => "varchar(32) NOT NULL default ''"
	),
	'height_css'    => array
	(
		'label'                   => &$GLOBALS['TL_LANG']['tl_page']['height_css'],
		'exclude'                 => true,
		'inputType'               => 'select',
		'options'				  => array('height-xxl','height-xl','height-l','height-m','height-s','height-xs','height-xxs'),
		'reference'				  => $GLOBALS['TL_LANG']['dca_theme_settings']['height_css'],
		'eval'                    => array('tl_class'=>'w50','includeBlankOption'=>true),
		'sql'                     => "varchar(32) NOT NULL default ''"
	),
	'imgHeadline'    => array
	(
		'label'                   => &$GLOBALS['TL_LANG']['tl_page']['imgHeadline'],
		'exclude'                 => true,
		'inputType'               => 'text',
		'eval'                    => array('tl_class'=>'clr w50','maxlength'=>255),
		'sql'                     => "varchar(255) NOT NULL default ''"
	),
	'imgSubheadline'    => array
	(
		'label'                   => &$GLOBALS['TL_LANG']['tl_page']['imgSubheadline'],
		'exclude'                 => true,
		'inputType'               => 'text',
		'eval'                    => array('tl_class'=>'w50','maxlength'=>255),
		'sql'                     => "varchar(255) NOT NULL default ''"
	),
	'addArticle'    => array
	(
		'label'                   => &$GLOBALS['TL_LANG']['tl_page']['addArticle'],
		'exclude'                 => true,
		'inputType'               => 'checkbox',
		'eval'                    => array('submitOnChange'=>true,'tl_class'=>'clr'),
		'sql'                     => "char(1) NOT NULL default ''"
	),
	'article'    => array
	(
		'label'                   => &$GLOBALS['TL_LANG']['tl_page']['article'],
		'exclude'                 => true,
		'inputType'               => 'select',
		'options_callback'        => array('PCT\ThemeSettings\Backend\TablePage', 'getArticles'),
		'eval'                    => array('includeBlankOption'=>true, 'chosen'=>true, 'mandatory'=>true),
		'sql'                     => "int(10) unsigned NOT NULL default '0'"
	),
));
