<?php

/**
 * Contao Open Source CMS
 * 
 * Copyright (C) 2005-2013 Leo Feyer
 * 
 * @copyright	Tim Gatzky 2016, Premium Contao Themes
 * @author		Tim Gatzky <info@tim-gatzky.de>
 * @package		pct_themer
 */

/**
 * Namespace
 */
namespace PCT\ThemeDesigner;

/**
 * Class file
 * Backend
 *
 */
class Frontend extends \Contao\Frontend
{
	public function getPageIdFromUrlCallback($arrFragments)
	{
		if(\Contao\Input::get('themedesigner_iframe'))
		{
			$arrFragments[] = 'themedesigner_iframe';
		}
		return $arrFragments;
	}	
	
	/**
	 * Append GET parameter to all urls in the iframe
	 * @param array
	 * @param string
	 * @param string
	 * @return string
	 */
	public function generateFrontendUrlCallback($arrRow, $strParams, $strUrl)
	{
		global $objPage;
		
		// do not manipulate active pages
		if(\Contao\Input::get('themedesigner_iframe') != '' && $arrRow['id'] != $objPage->id)
		{
			if(strlen(strpos($strUrl, '?')) > 0)
			{
				$strUrl .= '&themedesigner_iframe=1';
			}
			else
			{
				$strUrl .= '?themedesigner_iframe=1';
			}
		}
		return $strUrl;
	}


	/**
	 * Bypass Contaos preview mode
	 * @called from initializeSystem hook
	 */
	public function bypassContaoPreview($objPage)
	{
		if (\version_compare(VERSION,'4.9','>=') && TL_MODE == 'FE' && \strpos(\Contao\Environment::get('request'),'preview.php') !== false )
		{
			$objModel = \Contao\PageModel::findByPk( $objPage->id );
			// strip preview
			$strUrl = ltrim( ltrim($objModel->getFrontendUrl(),'preview.php'), '/');
			$strUrl = \Contao\Environment::get('base').$strUrl;
			
			\Contao\Controller::redirect($strUrl);
		}
	}
}
